#include <Servo.h>
// definicje nazw pinów włączników
#define S1 2
#define S2 3
#define S3 4
// definicje nazw pinów diod sygnalizujących stan pracy
#define D1 11
#define D2 12
#define D3 13
// definicje nazw pinów diod o regulowanym natężeniu światła
#define D4 5
#define D5 6
// definicje nazw pinów potencjometrów
#define P1 A0
#define P2 A1
#define P3 A2

int sekcja = 0; // numer wybranej sekcji (potencjometr logarytmiczny/linowy)
int pwm = 0;    //aktualna wartość PWM
int p = 0;      // wartość odczytana z potencjometru
int pozycja;    // pozycja ustawienia serwa

Servo serwomechanizm;

void setup() {
  serwomechanizm.attach(1);
  pinMode(S1, INPUT_PULLUP);
  pinMode(S2, INPUT_PULLUP);
  pinMode(S3, INPUT_PULLUP);
  pinMode(D1, OUTPUT);
  pinMode(D2, OUTPUT);
  pinMode(D3, OUTPUT);
  pinMode(D4, OUTPUT);
  pinMode(D5, OUTPUT);

  //sygnalizacja uruchomienia urządzenia
  digitalWrite(D1,HIGH);
  delay(500);
  digitalWrite(D1,LOW);
  digitalWrite(D2,HIGH);
  delay(500);
  digitalWrite(D2,LOW);
  digitalWrite(D3,HIGH);
  delay(500);
  digitalWrite(D3,LOW);
  pozycja = 0;
  serwomechanizm.write(pozycja);
}

void loop() {
if (not(digitalRead(S1)))  sekcja = 1;
if (not(digitalRead(S2)))  sekcja = 2;
if (not(digitalRead(S3)))  sekcja = 3;

switch (sekcja){
  case 1:
    p = analogRead(P1);
    digitalWrite(D1,HIGH);
    digitalWrite(D2, LOW);
    digitalWrite(D3, LOW);
    break;
  case 2:
    p = analogRead(P2);
    digitalWrite(D1,LOW);
    digitalWrite(D2, HIGH);
    digitalWrite(D3, LOW);
    break;
  case 3:
    p = analogRead(P3);
    digitalWrite(D1,LOW);
    digitalWrite(D2, LOW);
    digitalWrite(D3, HIGH);
    break;
}
  if (p>1010) p = 1010; // można użyć funkcji constrain()
  pwm = map(p,0,1010,0,255);
  analogWrite(D4,pwm);
  analogWrite(D5,pwm);
  pozycja=map(p,0,1010,0,180);
  serwomechanizm.write(pozycja);
  delay(100);
}
